/*
    43__fibonacci.c
    Zbog nepazljivo napisane rekurzije, moze se dogoditi da se ona
    mnogo puta poziva sa istom vrijednoscu parametra.
    Globalna varijabla broj_poziva vidljiva je svim funkcijama.
    -----
    Program pomocu rekurzivnih poziva funkcije fibo racuna n-ti Fibonaccijev
    broj. 
*/

#include <stdio.h>

int broj_poziva;

int fibo ( int n )
{
    broj_poziva++;
        
    if (n==0) return 0;
    if (n==1) return 1;
    
    return fibo(n-1) + fibo(n-2);
}


int main ()
{
    int broj;
    
    printf ("Unesite prirodni broj: ");
    scanf ("%d", &broj);
    
    broj_poziva=0;
    printf ("%d. Fibonacci-jev broj je %d.\n", broj, fibo (broj));
    printf ("Za njegov izracun funkcija fibo pozvana je %d puta.\n", 
             broj_poziva);
        
    return 0;   
}
