#include <stdio.h>

  /* Ucitava n i pise broj particija broja n,
     tj. broj rastava broja n u sumu nepadajucih
     prirodnih brojeva.
     Osnovni rekurzivni algoritam zbrajanjem.

     Prva ideja za efikasniji zavrsetak rekurzije.
     KOREKTNA realizacija.
  */

    /* Globalni brojac rekuzivnih poziva funkcije. */

unsigned int broj_poziva = 0u;

    /* Nadji sve particije broja suma u kojima je prvi (sljedeci)
       pribrojnik barem jednak prvi. */

int particije(int suma, int prvi)
{
    int i, broj = 0;

        /* Povecaj globalni brojac poziva funkcije. */
    ++broj_poziva;

        /* Znamo da u petlji sigurno ima bar jedna particija,
           ona za i = suma. */

        /* Rekurzivni pozivi - dodavanje sljedeceg pribrojnika i,
           za prvi <= i < suma. */
    for (i = prvi; i < suma; ++i)
        broj += particije( suma - i, i ) ;

        /* Ako je suma >= prvi, za i = suma, povecaj broj za 1. */
    if (suma >= prvi) ++broj;
    return broj;
}

int main(void)
{
    int n;

    printf(" Upisi prirodni broj n: ");
    scanf("%d", &n);

    printf("\n Broj particija p(%d) = %d\n",
           n, particije(n, 1) );

    printf("\n Broj poziva funkcije = %u\n",
           broj_poziva);

    return 0;
}
