#include <stdio.h>

  /* Sortiranje QuickSort algoritmom.
     Varijanta iz Wirtha (A+DS=P):
     x[srednji] je kljucni element i
     dovodimo ga na pravo mjesto u polju. */
  /* Pise sve bitne stvari u algoritmu. */

void swap(int *a, int *b)
{
    int temp;

    temp = *a;
    *a = *b;
    *b = temp;

    return;
}

void quick_sort(int x[], int l, int d)
{
    int i, j, s;

    printf("\n QuickSort(%d, %d):\n", l, d);

    s = (l + d) / 2;
    i = l;
    j = d;
    printf("   start:  s = %d\n", s);
    printf("   start:  i = %d, j = %d\n", i, j);

        /* Prolaz mora i za i == j */
    do {
        printf("     do-while, vrh:  i = %d, j = %d\n", i, j);
        while (x[i] < x[s]) ++i;
        while (x[j] > x[s]) --j;
        printf("         iza while:  i = %d, j = %d\n", i, j);
        if (i <= j) {
                /* Zamjena ne treba za i == j */
            swap(&x[i], &x[j]);
            printf("        zamjena:  x[%d] <-> x[%d]\n", i, j);
            printf("        sada je:  x[%d] = %d,  x[%d] = %d\n",
                    i, x[i], j, x[j]);
            ++i;
            --j;
        }
        printf("     do-while, dno:  i = %d, j = %d\n", i, j);
    }
    while (i <= j);

    printf("    kraj:  l = %d, j = %d\n", l, j);
    printf("    kraj:  i = %d, d = %d\n", i, d);
    if (l < j) quick_sort(x, l, j);
    if (i < d) quick_sort(x, i, d);

    return;
}

int main(void) {
    int i, n;
    int x[] = {42, 12, 55, 94, 18, 44, 67};

    n = 7;

    printf("\n Nesortirano polje x:\n");
    for (i = 0; i < n; ++i) {
        printf(" x[%d] = %d\n", i, x[i]);
    }

    quick_sort(x, 0, n - 1);

    printf("\n Sortirano polje x:\n");
    for (i = 0; i < n; ++i) {
        printf(" x[%d] = %d\n", i, x[i]);
    }
    return 0;
}
