#include <stdio.h>
#include <math.h>

double integracija(double, double,
                   double (*)(double));

int main(void)
{
    printf("Sin: %f\n", integracija(0, 1, &sin));
    printf("Cos: %f\n", integracija(0, 1, &cos));

    return 0;
}

double integracija(double a, double b,
                   double (*f)(double))
{
    return 0.5 * (b - a) * ( (*f)(a) + (*f)(b) );
}
