  /* Zaglavlje tocka.h koje definira tip tocka.
     Ukljucujemo u svaki program koji ga koristi.

     Implementacija je u datoteci tocka.c. */

typedef struct {
    double x;
    double y;
} tocka;

  /* Neke funkcije koje rade na ovom slozenom
     tipu podataka. Ovdje su samo deklaracije.
     Njihova implementacija je u tocka.c */

  /* Udaljenost tocaka. */
double udaljenost(tocka, tocka);

  /* Udaljenost tocke od ishodista. */
double udaljenost_od_ishodista(tocka);

  /* Centralno simetricna tocka
     obzirom na ishodiste. */
tocka centralno_simetricna(tocka);

  /* Translacija tocku za drugu tocku (vektor). */
void translatiraj_tocku(tocka*, tocka);

  /* Ispisuje tocke u obliku ime_tocke(x, y). */
void ispisi_tocku(char *, tocka);
