/* ======================================================================== */

lista merge(lista prvi_1, lista prvi_2)
{
        /* Sortirano spaja dvije liste (merge). */

    lista prvi = NULL, zadnji, pom;

    if (prvi_1 == NULL) return prvi_2;
    if (prvi_2 == NULL) return prvi_1;

    while (prvi_1 != NULL && prvi_2 != NULL) {
        if (prvi_1->broj <= prvi_2->broj) {
            pom = prvi_1;
            prvi_1 = prvi_1->sljed;
        }
        else {
            pom = prvi_2;
            prvi_2 = prvi_2->sljed;
        }
        if (prvi == NULL)
            prvi = pom;
        else
            zadnji->sljed = pom;
        zadnji = pom;
    }

    if (prvi_1 == NULL)
        zadnji->sljed = prvi_2;

    if (prvi_2 == NULL)
        zadnji->sljed = prvi_1;

    return prvi;
}

/* ======================================================================== */

lista merge_rek(lista prvi_1, lista prvi_2)
{
        /* Sortirano spaja dvije liste (merge). */
        /* Rekurzivna varijanta. */

    lista prvi;

    if (prvi_1 == NULL) return prvi_2;
    if (prvi_2 == NULL) return prvi_1;

    if (prvi_1->broj <= prvi_2->broj) {
        prvi = prvi_1;
        prvi->sljed = merge_rek(prvi_1->sljed, prvi_2);
    }
    else {
        prvi = prvi_2;
        prvi->sljed = merge_rek(prvi_1, prvi_2->sljed);
    }

    return prvi;
}

/* ======================================================================== */

lista merge_sort(lista prvi)
{
        /* Sortira listu Merge_Sort algoritmom. */

    lista zadnji, prvi_2;

        /* Test na praznu ili jednoclanu listu. */

    if ((prvi == NULL) || (prvi->sljed == NULL))
        return prvi;

        /* ``Raspolovi'' listu. Pokazivac zadnji
           pokazuje na zadnjeg u prvom dijelu.
           Pokazivac prvi_2 je trenutno pomocni
           i sluzi za raspolavljanje liste. */

    zadnji = prvi;
    prvi_2 = prvi->sljed;

        /* Pomicemo zadnjeg za JEDNO mjesto,
           a prvi_2 za DVA mjesta, sve dok
           prvi_2 ne stigne do kraja liste. */

    while ((prvi_2 != NULL) &&
           (prvi_2->sljed != NULL)) {

        zadnji = zadnji->sljed;
/*
   NE VALJA:
        prvi_2 = zadnji->sljed->sljed;
*/
        prvi_2 = prvi_2->sljed->sljed;
    }

        /* Pokazivac zadnji sad korektno pokazuje
           na zadnjeg u prvom dijelu.
           Pokazivac prvi_2 postavljamo na prvog
           u drugom dijelu (prvi iza zadnjeg) i
           korektno zavrsavamo prvi dio. */

    prvi_2 = zadnji->sljed;
    zadnji->sljed = NULL;

    prvi = merge(merge_sort(prvi),
                 merge_sort(prvi_2));

    return prvi;
}

/* ======================================================================== */
