#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

int main(int argc, char *argv[])
{
    char s[129];
    FILE *ulaz, *izlaz;
    int uvjet, n, i;

    printf("Ulazna datoteka: %s\n", argv[1]);
    printf("Izlazna datoteka: %s\n", argv[2]);

    ulaz = fopen(argv[1], "r");
    if (ulaz == NULL) {
        printf(" Greska na ulazu!\n");
        exit(2);
    }
    izlaz = fopen(argv[2], "w");
    if (izlaz == NULL) {
        printf(" Greska na izlazu!\n");
        exit(3);
    }

        /* Test feof prije citanja NE radi
           iza zadnje rijeci - treba ekstra test. */

    while (!feof(ulaz)) {    /* feof(ulaz) == 0 */
          /* Kontrola citanja. */
        if (fscanf(ulaz, "%s", s) < 1) break;
/* Moze i ovako:
        if (fscanf(ulaz, "%s", s) == EOF) break;
*/
        n = strlen(s);

        printf("duljina = %d, rijec = %s\n", n, s);

        if (n > 4) {
            uvjet = 1;
            i = 0;
            while (i < n && uvjet) {
              /* umjesto i < n, moze s[i] != '\0' */
                uvjet = uvjet && !isalpha(s[i]);
                ++i;
            }
            if (uvjet)
                fprintf(izlaz, "%s\n", s);
        }
    }

    fclose(ulaz);
    fclose(izlaz);

    return 0;
}
